// might adopt some strange functions from Module?
// var maximJs = Module;

// alternatively...
// probably better this way
// no inheritance of Module stuff...
var maximJs = {};

maximJs.maxiSettings = Module.maxiSettings;
maximJs.maxiOsc = Module.maxiOsc;
maximJs.maxiEnvelope = Module.maxiEnvelope;
maximJs.maxiDelayline = Module.maxiDelayline;

maximJs.maxiFilter = Module.maxiFilter;
maximJs.maxiMix = Module.maxiMix;
maximJs.maxiLagExp = Module.maxiLagExp;
maximJs.maxiSample = Module.maxiSample;

maximJs.maxiMap = Module.maxiMap;
maximJs.maxiDyn = Module.maxiDyn;
maximJs.maxiEnv = Module.maxiEnv;
maximJs.convert = Module.convert;

maximJs.maxiDistortion = Module.maxiDistortion;
maximJs.maxiFlanger = Module.maxiFlanger;
maximJs.maxiChorus = Module.maxiChorus;

maximJs.maxiEnvelopeFollower = Module.maxiEnvelopeFollower;
maximJs.maxiClock = Module.maxiClock;

// LIBS
// FFT-ish
maximJs.maxiFFT = Module.maxiFFT;
maximJs.maxiIFFT = Module.maxiIFFT;
maximJs.maxiMFCC = Module.maxiMFCC;
maximJs.maxiFFTOctaveAnalyzer = Module.maxiFFTOctaveAnalyzer;

// Grains
maximJs.maxiTimestretch = Module.maxiTimestretch;
maximJs.maxiPitchShift = Module.maxiPitchShift;
maximJs.maxiPitchStretch = Module.maxiPitchStretch;

// ------------------------------------------------
// maxiArray - could extend Array object?
// cheaty array method to avoid mixing vector terminology with arrays
// but have to copy everything?!
// better to use GetArrayAsVectorDbl function ???
maximJs.maxiArray = function maxiArray(){
    this.length = 0;
    var vec = new Module.VectorDouble();

// this.update = function(){
//     var lengthsMatch = this.length !== this.vec.size();
//     if(!lengthsMatch){
//         if(this.length < this.vec.size()){
//             for(var i = this.length; i < this.vec.size(); i++){
//                 this[i] = this.vec.get(i);
//             }
//         } else{
//             for(var i = this.length; i < this.vec.size(); i++){
//                 delete this[i];
//             }
//         }

//         // reset length var
//         this.length = this.vec.size();
//     } 
// };
};

maximJs.maxiArray.prototype.asVector = function(arrayIn){
    return this.vec;
};

maximJs.maxiArray.prototype.asJsArray = function(arrayIn){
    var arrayOut = [];

    for(var i = 0; i < this.length; i++){
        array.push(this.vec.get(i));
    }

    return arrayOut;
};

maximJs.maxiArray.prototype.set = function(arrayIn){
    this.clear();
    this.vec = GetArrayAsVectorDbl(arrayIn);
    this.length = this.vec.size();
    this.SetSqBrackets(true);
};

maximJs.maxiArray.prototype.push = function(num){
    this.vec.push_back(num);
    this[this.length] = num;
    this.length++;
};

// set object properties to mimic array
// this doesn't seem particularly efficient or smart
maximJs.maxiArray.prototype.SetSqBrackets = function(useSq){
    for(var i = 0; i < this.length; i++){
        if(useSq){
            this[i] = this.vec.get(i);
        } else{
            delete this[i];
        }
    }
};

maximJs.maxiArray.prototype.clear = function(useSq){
    for(var i = 0; i < this.length; i++){
        delete this[i];
    }
    Module.vectorTools.clearVectorDbl(this.vec);
    this.length = 0;
};



// tools
maximJs.maxiTools = function(){};

maximJs.maxiTools.arrayOfObj = function(obj, num){
    var array = [];

    for(var i = 0; i < num; i++){
        array.push(new obj());
    }
    return array;
};

maximJs.maxiTools.getArrayAsVectorDbl = function(arrayIn){
    var vecOut = new Module.VectorDouble();
    for(var i = 0; i < arrayIn.length; i++){
        vecOut.push_back(arrayIn[i]);
    }

    return vecOut;
};

maximJs.maxiTools.loadSample = function(url, samplePlayer, contextIn) {
    var data = [];
    var context;

    if(!contextIn){
        // context = GetContext();
        context = new (window.AudioContext || window.webkitAudioContext)();
    } else {
        context = contextIn;
    }

    samplePlayer.clear();

    // Load asynchronously
    var request = new XMLHttpRequest();
    request.addEventListener("load",
        function (evt) {
          console.log("The transfer is complete.");
      });
    request.open("GET", url, true);

    request.responseType = "arraybuffer";

    request.onload = function() {
        context.decodeAudioData(
            request.response,
            function(buffer) {
                // source.buffer = buffer;
                // source.loop = true;
                // source.start(0);
                data = buffer.getChannelData(0);

                if(data){
                    var myBufferData = new Module.VectorDouble();
                    // Module.vectorTools.clearVectorDbl(myBufferData);

                    for(var n = 0; n < data.length; n++){
                        myBufferData.push_back(data[n]);
                    }

                    samplePlayer.setSample(myBufferData/*, context.sampleRate*/);
                }

            },

            function(buffer) {
                console.log("Error decoding source!");
            }
            );
    };

    request.send();
};


// ------------------------------------------------
maximJs.maxiAudio = function(){};
maximJs.maxiAudio.output = 0;
maximJs.maxiAudio.numChannels = 2; // should be private

maximJs.maxiAudio.context = null;
maximJs.maxiAudio.source = null;
maximJs.maxiAudio.analyser = null;
maximJs.maxiAudio.jsProcessor = null;

maximJs.maxiAudio.play = function(){};

// don't really need setup??
maximJs.maxiAudio.setup = function(){
    console.log("non-overrided setup");
};

// isArray should be second param really
// set num channels and set output as an array
// use this if you want to change number of channels
maximJs.maxiAudio.setNumChannels = function(isArray, numChannels_){
    this.numChannels = numChannels_;
    this.outputIsArray(isArray, numChannels_);

    this.resetAudio();
};

// use this if you want to keep num of outputs but change
// method e.g. array or not
maximJs.maxiAudio.outputIsArray = function(isArray, numChannels_){
    if(isArray){
        maximJs.maxiAudio.output = new Array(numChannels_);

        for(var i = 0; i < numChannels_; i++){
            maximJs.maxiAudio.output[i] = 0;
        }
    } else {
        maximJs.maxiAudio.output = 0;
    }
};

// function handling audio processing
// called byjsProcessor
maximJs.maxiAudio.process = function(event) {
    var numChannels = event.outputBuffer.numberOfChannels;
    var outputLength = event.outputBuffer.getChannelData(0).length;

    for (var i = 0; i < outputLength; ++i) {
        maximJs.maxiAudio.play();

        if(maximJs.maxiAudio.output instanceof Array){
            for (var channel = 0; channel < numChannels; channel++) {
                event.outputBuffer.getChannelData(channel)[i] = maximJs.maxiAudio.output[channel];
            }
        }
        else
        {
           for (var channel = 0; channel < numChannels; channel++) {
            event.outputBuffer.getChannelData(channel)[i] = maximJs.maxiAudio.output;
        }
    }
}
};

maximJs.maxiAudio.resetAudio = function(){
    this.source.disconnect();
    this.jsProcessor.disconnect();
    this.analyser.disconnect();

    this.init();
};

maximJs.maxiAudio.init = function() {
    // Temporary patch until all browsers support unprefixed context.
    this.context = new (window.AudioContext || window.webkitAudioContext)();

    this.source = this.context.createBufferSource();
    this.jsProcessor = this.context.createScriptProcessor(4096, this.numChannels, this.numChannels);
    this.jsProcessor.onaudioprocess = this.process;

    this.analyser = this.context.createAnalyser();
    this.analyser.fftSize = 2048;

    // Connect the processing graph: source -> jsProcessor -> analyser -> destination
    this.source.connect(this.jsProcessor);
    this.jsProcessor.connect(this.analyser);
    this.analyser.connect(this.context.destination);
};

/*
maximJs.maxiAudio = function maxiAudio(){
// Temporary patch until all browsers support unprefixed context.
this.context = new (window.AudioContext || window.webkitAudioContext)();
this.source = 0;
this.jsProcessor = 0;
this.analyser = 0;

this.output = 0;
this.bufferLoader = 0;

this.myBufferData = new Module.VectorDouble();//this data will be used to make an envelope. Value and time to value in ms.

// this.init();

this.setup = function(){
    console.log("non-overrided setup");
    // setNumChannels(2);
};

// this will be overriden in the users script
this.play = function(){
    // output = 0;
    // console.log("non-overrided play");
};

this.initAudio = function(numChannels) {
    this.source = this.context.createBufferSource();

    this.jsProcessor = this.context.createScriptProcessor(4096, numChannels, numChannels);
    this.jsProcessor.onaudioprocess = this.process;

    this.analyser = this.context.createAnalyser();
    this.analyser.fftSize = 2048;

    // // Connect the processing graph: source -> jsProcessor -> analyser -> destination
    this.source.connect(this.jsProcessor);
    this.jsProcessor.connect(this.analyser);
    this.analyser.connect(this.context.destination);
};

// set num channels and set output as an array
// use this if you want to change number of channels
this.setNumChannels = function(isArray, numChannelsOut_){
    if(isArray){
        this.OutputIsArray(true, numChannelsOut_);
    } else {
        this.OutputIsArray(false, numChannelsOut_);
    }

    this.source.disconnect();
    this.jsProcessor.disconnect();
    this.analyser.disconnect();

    this.initAudio(numChannelsOut_);
};

// use this if you want to keep num of outputs but change
// method e.g. array or not
this.OutputIsArray = function(isArray, numChannelsOut_){
    if(isArray){
        this.output = new Array(numChannelsOut_);

        for(var i = 0; i < numChannelsOut_; i++){
            this.output[i] = 0;
        }
    } else {
        this.output = 0;
    }
};

// function handling audio processing
// called byjsProcessor
this.process = function(event) {
    var numChannels = event.outputBuffer.numberOfChannels;
    var outputLength = event.outputBuffer.getChannelData(0).length;


    for (var i = 0; i < this.outputLength; ++i) {
        this.play();

        if(this.output instanceof Array){
            for (var channel = 0; channel < this.numChannels; channel++) {
                event.outputBuffer.getChannelData(channel)[i] = this.output[channel];
            }
        }
        else
        {
         for (var channel = 0; channel < this.numChannels; channel++) {
            event.outputBuffer.getChannelData(channel)[i] = this.output;
        }
    }
}
};

this.init = function() {
    this.initAudio(2);
    this.setup();
};

this.GetContext = function(){
    if(this.context){
        return this.context;
    }
};


};
*/

/*
// depreciated
function loadSample(url, samplePlayer, contextIn) {
    var data = [];
    var context;

    if(!contextIn){
        context = GetContext();
    } else {
        context = contextIn;
    }

    samplePlayer.clear();

    sampleIsLoaded = false;
    // Load asynchronously
    var request = new XMLHttpRequest();
    request.addEventListener("load", transferComplete);
    request.open("GET", url, true);

    request.responseType = "arraybuffer";

    request.onload = function() {
        context.decodeAudioData(
            request.response,
            function(buffer) {
                // source.buffer = buffer;
                // source.loop = true;
                // source.start(0);
                data = buffer.getChannelData(0);

                if(data){
                    Module.vectorTools.clearVectorDbl(myBufferData);

                    for(var n = 0; n < data.length; n++){
                        myBufferData.push_back(data[n]);
                    }

                    samplePlayer.setSample(myBufferData);
                    sampleIsLoaded = true;
                }

            },

            function(buffer) {
                console.log("Error decoding source!");
            }
            );
    };

    request.send();

}
*/
